package Multiuser;
use strict;
require Exporter;
use vars qw (@ISA @EXPORT);
@ISA    = qw(Exporter);    # Inherit from Exporter
@EXPORT = qw(
	$CurrentToken
	%Tokens
	%sessions
	$Session
	@CurrentProperties
	$SessionDir
	StartSession
	SaveSession
	SaveAllSessions
	isAdmin
);
use strict;
use warnings;
use Common;

# ---------------------------------------------------------------------------------------------
# constants
# ---------------------------------------------------------------------------------------------
# variables

# %session main keys are session tokens, 2nd level is 'current' 'edit' 'editable'
use vars qw(
	$CurrentToken
	%Tokens
	%sessions
	$Session
	@CurrentProperties
	$SessionDir
);

@CurrentProperties = ('adminmode', 'action', 'view', 'account', 'statement', 'transaction', 'detail', 'showarchived', 'message', 'error', 'deleteclicked', 'transactionsort','query' );
$SessionDir = "${DataDir}/Sessions";

# ---------------------------------------------------------------------------------------------
sub StartSession {
	my ($token) = @_;
	my $username = $Tokens{$token}{username};
	$sessions{$token}{current}{_hash} = 1 if ! exists $sessions{$token}{current};
	$sessions{$token}{edit}{_hash} = 1 if ! exists $sessions{$token}{edit};
	$sessions{$token}{editable}{_hash} = 1 if ! exists $sessions{$token}{editable};
	$Session = $sessions{$token};	
	foreach my $property ( @CurrentProperties) {
		$Session->{current}{$property} = $defaults{session}{$property} || '';
	}
	LoadPropertyFile("$SessionDir/$username.session",$Session->{current});
	$Session->{current}{action} = '' if $Session->{current}{action} eq 'query';
	$Session->{current}{adminmode} = 0;
	$Session->{current}{account}     = '' if !$Session->{current}{account}     or !$Accounts{ $Session->{current}{account} };
	$Session->{current}{statement}   = '' if !$Session->{current}{statement}   or !$Statements{ $Session->{current}{statement} };
	$Session->{current}{transaction} = '' if !$Session->{current}{transaction} or !$Transactions{ $Session->{current}{transaction} };
	$Session->{current}{detail}      = '' if !$Session->{current}{detail}      or !$Details{ $Session->{current}{detail} };
}

sub SaveSession {
	my ($token) = @_;
	$token = $CurrentToken if !$token;
	return if !$Tokens{$token};
	my $username = $Tokens{$token}{username};
	mkdir $SessionDir,0777 if ! -d $SessionDir;		
	open my $SESSION, ">", "$SessionDir/$username.session";
	foreach my $entry (sort keys %{$sessions{$token}{current}}) {
		print $SESSION "$entry=$sessions{$token}{current}{$entry}\n";
	}
	close $SESSION;
}

sub SaveAllSessions {
	foreach my $token ( keys %Tokens ) {
		SaveSession($token);
	}
}

sub isAdmin {
	return TRUE if !$properties{authentication};
	my $user = $Tokens{$CurrentToken}{username};
	return TRUE if $Users{$user}{admin};
	return FALSE;
}

# ---------------------------------------------------------------------------------------------
# End
1;

