package Pages;
use strict;
require Exporter;
use vars qw (@ISA @EXPORT);
@ISA    = qw(Exporter);    # Inherit from Exporter
@EXPORT = qw(
	ShowPage
);
use strict;
use warnings;
use Common;
use DateIncrement;
use Multiuser;
use Data;
use HTML;
use Queries;
use Reports;

# ---------------------------------------------------------------------------------------------
# Pages
sub ShowPage {
	LoadColors() if !%colors;
	$Session->{editable} = {};
	HTTPHeader();
	HTMLHeader();
	my $onload = $onload ? "onload=\"javascript:document.getElementById('$onload').focus();\"" : "";
	print HTMLStart("body $onload");
	print HTMLStartEnd( "form method=POST id='select' name='select' action=''", HTMLSingle("input type=hidden name='field' value=''"), HTMLSingle("input type=hidden name='value' value=''"), HTMLSingle("input type=hidden name='action' value='select'") );
	print HTMLStartEnd( "form method=POST id='doview' name='doview' action=''", HTMLSingle("input type=hidden name='view' value=''") );
	print HTMLStart( 'div' . ClassAttribute('page border') );
	ShowPageHeader();
	ShowPageContent();
	print HTMLEnd('div');    #wrapper
	print HTMLEnd('body');
	print HTMLEnd('html');
}

sub ShowPageHeader {
	print HTMLStart( 'div' . ClassAttribute('header') );    # entire header
	print HTMLStartEnd( 'div' . ClassAttribute('showview'), 'View: ' . ucfirst( $Session->{current}{view} ) );
	ShowTitle();
	print Indented( Button( $Session->{current}{adminmode} ? 'Turn Admin Off' : 'Turn Admin On', 'admin', 'Select', 'mode', 'adminmode' ) ) if isAdmin();
	print HTMLSingleIndented( 'hr' . ClassAttribute('nomargin') );
	ShowLowerHeader();
	print HTMLEnd('div');
}

sub ShowTitle {
	print HTMLStart( 'div' . ClassAttribute('title') );
	print HTMLStartEnd( 'h1' . ClassAttribute('nomargin refresh'), $Title . ' ' . HTMLEnclosed( 'small', HTMLEnclosed( 'small', 'Version ' . $Version ) ) );
	print HTMLEnd('div');
}

sub ShowLowerHeader {
	print HTMLStart( 'div' . ClassAttribute('lowerheader') );
	ShowLowerLeftHeader();
	ShowLowerMiddleHeader();
	ShowLowerRightHeader();
	print HTMLEnd('div');
}

sub ShowLowerLeftHeader {
	print HTMLStart( 'div' . ClassAttribute('lowerleftheader') );
	ShowAccountsMenu();
	$Session->{current}{adminmode} ? ShowAdminMenu() : ShowReportsMenu();
	ShowTransactionsMenu();
	print HTMLEnd('div');
}

sub ShowAccountsMenu {
	print HTMLStart( 'div' . ClassAttribute('menurow') );
	print Indented( Button( 'Account Info', 'menuaccount', 'doView', 'accountinfo' ) ) if $isExistingAccount;
	print Indented( Button( $Session->{current}{showarchived} ? 'Show Active Accounts' : 'Show Archived Accounts', 'menuaccount', 'doView', 'archived' ) );
	print Indented( Button( 'New Account', 'menuaccount', 'Select', 'account', 'new' ) ) if !$Session->{current}{showarchived} and isAdmin();
	print Indented( Button( 'Edit Account', 'menuaccount', 'doView', 'accounts' ) ) if !$viewAccounts and isAdmin();
	print HTMLEnd('div');
	ResetFloat();
}

sub ShowReportsMenu {
	my $statement = $Session->{current}{statement};
	print HTMLStart( 'div' . ClassAttribute('menurow') );
	if ($isExistingAccount) {
		print Indented( Button( 'Balance Report',                                                 'menustatement', 'Select', 'report', 'balancereport',     TRUE ) );
		print Indented( Button( 'Credit Utilization',                                             'menustatement', 'Select', 'report', 'creditutilization', TRUE ) );
		print Indented( Button( 'Full Report',                                                    'menustatement', 'Select', 'report', 'fullreport',        TRUE ) );
		print Indented( Button( 'Print ' . $Statements{$statement}{statementdate} . ' Statement', 'menustatement', 'Select', 'report', 'print',             TRUE ) )
			if $statement
			and !$isCurrent
			and !$isRecurring;
		print Indented( Button( 'Print Current Statement', 'menustatement', 'Select', 'report', 'print',          TRUE ) );
		print Indented( Button( 'Print Uncleared',         'menustatement', 'Select', 'report', 'printuncleared', TRUE ) );
		print Indented( Button( 'Print Recurring',         'menustatement', 'Select', 'report', 'printrecurring', TRUE ) );
	}
	print HTMLEnd('div');
	ResetFloat();
}

sub ShowAdminMenu {
	my $account   = $Session->{current}{account};
	my $statement = $Session->{current}{statement};
	print HTMLStart( 'div' . ClassAttribute('menurow') );
	if ($isExistingAccount) {
		print Indented( Button( 'Fix Account Balances From Current Statment', 'menuadmin', 'Select', 'report', 'printunclearedfix' ) );
		print Indented( Button( "Recalculate Balances for $Accounts{$account}{accountname}",                                        'menuadmin', 'doView', 'recalc' ) );
		print Indented( Button( "Recalculate Balances for $Accounts{$account}{accountname}/$Statements{$statement}{statementdate}", 'menuadmin', 'doView', 'recalcstatement' ) )
			if $statement
			and $statement ne 'new'
			and !$isRecurring;
		print Indented( Button( 'Fix Statements', 'menuadmin', 'Select', 'report', 'fixstatements' ) ) if $fixAvailable;
	}
	print HTMLEnd('div');
	ResetFloat();
}

sub ShowTransactionsMenu {
	my $account = $Session->{current}{account};
	print HTMLStart( 'div' . ClassAttribute('menurow') );
	if ( !$Session->{current}{adminmode} ) {
		if ($isExistingAccount) {
			if ($viewTransactions) {
				print Indented( Button( 'New &Transaction', 'menutransaction', 'Select', 'transaction', 'new' ) ) if ( $isCurrent or $isRecurring );
				print Indented( Button( 'Queries', 'menutransaction', 'doView', 'queries' ) ) if !$viewQueries;
				print Indented( Button( 'Sort by Date', 'menutransaction', 'Select', 'transactionsort', 'date' ) ) if $Session->{current}{transactionsort} ne 'date';
				print Indented( Button( 'Sort by Description', 'menutransaction', 'Select', 'transactionsort', 'description' ) )
					if $Session->{current}{transactionsort} ne 'description';
				print Indented( Button( "Sort by Check# (last check: $Accounts{$account}{lastcheck})", 'menutransaction', 'Select', 'transactionsort', 'checknumber' ) )
					if $Session->{current}{transactionsort} ne 'checknumber' and $Accounts{$account}{accounttype} eq 'd';
				print Indented( Button( 'Sort by Amount', 'menutransaction', 'Select', 'transactionsort', 'amount' ) ) if $Session->{current}{transactionsort} ne 'amount';
				if ( ( $isCurrent or $isRecurring ) and exists $Session->{deleted} and exists $Session->{deleted}{amount} ) {
					my $amount      = '$' . $Session->{deleted}{amount};
					my $description = $Session->{deleted}{description};
					$description =~ s" .*"";
					print Indented( Button( "Undelete Transaction ($description:$amount)", 'menutransaction', 'Select', 'undeletetransaction', '' ) );
				}
			} else {
				print Indented( Button( 'Transactions', 'menutransaction', 'doView', 'transactions' ) );
				print Indented( Button( 'Queries', 'menutransaction', 'doView', 'queries' ) ) if !$viewQueries;
			}
		} else {
			print Indented( Button( 'Queries', 'menutransaction', 'doView', 'queries' ) ) if !$viewQueries;
		}
	}
	ResetFloat();
	print HTMLEnd('div');
}

sub ShowLowerMiddleHeader {
	print HTMLStart( 'div' . ClassAttribute('lowermiddleheader') );
	ShowPageError();
	ShowPageMessage();
	print HTMLEnd('div');
}

sub ShowLowerRightHeader {
	my $adminmode = $Session->{current}{adminmode};
	my $username  = $Tokens{$CurrentToken}{username};
	print HTMLStart( 'div' . ClassAttribute('lowerrightheader') );
	print Indented( Button( "&Logout $username", 'menucommand', 'doView', 'logout' ) ) if !$adminmode and $properties{authentication};
	print Indented( Button( '&Quit',             'menucommand', 'doView', 'quit' ) )   if !$adminmode and !$properties{authentication};
	print Indented( Button( 'Shutdown', 'menucommand', 'doView', 'shutdown' ) ) if $adminmode;
	ResetFloat();
	print Indented( Button( 'Configure Program', 'menucommand', 'doView', 'configure' ) ) if $adminmode;
	print Indented( Button( 'Configure Users',   'menucommand', 'doView', 'users' ) )     if $adminmode and $properties{authentication};
	print Indented( Button( 'Configure Users',   'menucommand', 'doView', 'users' ) )     if $adminmode;                                   #################################################
	print HTMLStartEnd( 'div' . ClassAttribute('blankrow'), '&nbsp;' ) if !$adminmode;
	ResetFloat();
	print HTMLEnd('div');
}

sub ShowPageError {
	my $error = $Session->{current}{error};
	return if !$error;
	print HTMLStartEnd( 'div' . ClassAttribute('error'), HTMLBreaks($error) );
}

sub ShowPageMessage {
	my $message = $Session->{current}{message};
	return if !$message;
	print HTMLStartEnd( 'div' . ClassAttribute('message'), HTMLBreaks($message) );
}

sub ShowPageContent {
	print HTMLStart( 'div' . ClassAttribute('contentarea') );
	ShowAccounts();
	if ($viewAccounts) {
		ShowAccountEdit();
	} elsif ($viewTransactions) {
		ShowTransactions();
		ShowDetails();
		ShowStatements();
	} elsif ($viewQueries) {
		ShowQueryForm();
		ShowQueryResults();
	} elsif ($viewReports) {
		ShowReportForm();
		ShowReport();
	}
	print HTMLEnd('div');    #content
}

# ---------------------------------------------------------------------------------------------
sub ShowAccounts {
	print HTMLStart( 'div' . ClassAttribute('content accounts') );
	print HTMLStartEnd( 'div' . ClassAttribute('accountsheader'), 'Bank Accounts' );
	my %showAccounts;
	my %groups = ( 'c' => 'Credit Accounts', 'd' => 'Debit Accounts', 'z' => 'Zero Balance Accounts' );
	foreach my $account ( keys %Accounts ) {
		next if !$Accounts{$account}{archived} ne !$Session->{current}{showarchived};
		my $group = $Accounts{$account}{accounttype};
		$group = 'z' if !$Accounts{$account}{balance};
		$showAccounts{$group}{ $Accounts{$account}{accountname} } = { account => $account, balance => "$Accounts{$account}{balance}" };
	}
	foreach my $group ( 'd', 'c', 'z' ) {
		next if !$showAccounts{$group};
		print Indented( HTMLEnclosed( 'span' . ClassAttribute('accountlistitem accountlistgroup'), "---------- " . $groups{$group} . " ----------" ) );
		foreach my $AccountName ( sort { uc($a) cmp uc($b) } keys %{ $showAccounts{$group} } ) {
			my $account = $showAccounts{$group}{$AccountName}{account};
			my $name    = "<span>$AccountName</span>";
			my $balance = "<span style='float:right'>" . Display( FormatAmount( $showAccounts{$group}{$AccountName}{balance} ) ) . "</span>";
			my $desc    = $balance . $name;
			print Indented( Select( $desc, 'accountlistitem', 'account', $account ) );
		}
	}
	print Indented("No archived accounts.") if $Session->{current}{showarchived}  and !%showAccounts;
	print Indented("No active accounts.")   if !$Session->{current}{showarchived} and !%showAccounts;
	print HTMLEnd('div');
}

sub ShowAccountEdit {
	my $account = $Session->{current}{account};
	return if !$account;
	if ( $account ne 'new' and !$Accounts{$account}{archived} ne !$Session->{current}{showarchived} ) {
		$Session->{current}{account} = '';
		return;
	}
	foreach my $field ( keys %{ $moneyFields{account} } ) {
		$Session->{edit}{account}{$field} = FormatAmount( Amount( $Session->{edit}{account}{$field} ), 1 );
	}
	EditFormHeader( 'account', $account );
	print HTMLStartEnd( "tr", HTMLStartEnd( 'th colspan=2' . ClassAttribute('accountsheader'), "Bank Account" ) );
	EditField( 'account', 'Account Name', 30 );
	my $selectType = "";
	foreach my $accounttype ( sort keys %AccountTypes ) {
		$selectType .= RadioButton( 'account', 'accounttype', $accounttype, $AccountTypes{$accounttype}{label} );
	}
	TableRow( 'Account Type', $selectType, 'account', 'accounttype' );
	EditField( 'account', 'Account Number' );
	EditField( 'account', 'Routing Number' );
	EditField( 'account', 'Card Number' );
	EditField( 'account', 'Expiration Date', 5 );
	EditField( 'account', 'Security Code', 3 );
	EditField( 'account', 'Credit Limit' );
	EditField( 'account', 'Interest Rate', '', '', '%' );
	EditField( 'account', 'Balance',         '', TRUE );
	EditField( 'account', 'Cleared Balance', '', TRUE );
	EditField( 'account', 'Last Check',      '', TRUE );
	my $Buttons = Button( 'Save', 'editaccountbutton', 'Submit', 'editaccount', 'save' );

	if ( $account ne "new" ) {
		$Buttons .= Button( 'Delete',   'editaccountbutton', 'Submit', 'editaccount', 'delete' )   if $Session->{current}{adminmode};
		$Buttons .= Button( 'Archive',  'editaccountbutton', 'Submit', 'editaccount', 'archive' )  if !$Accounts{$account}{archived};
		$Buttons .= Button( 'Activate', 'editaccountbutton', 'Submit', 'editaccount', 'activate' ) if $Accounts{$account}{archived};
	}
	print HTMLStartEnd( 'tr', HTMLEnclosed( 'td colspan=2', $Buttons ) );
	EditFormFooter();
}

# ---------------------------------------------------------------------------------------------
sub ShowStatements {
	my $account = $Session->{current}{account};
	return if !$account or $isNewAccount;
	print HTMLStart( 'div' . ClassAttribute('contentgroup') );
	ShowStatementEdit();
	ShowStatementList();
	ResetFloat();
	print HTMLEnd('div');
}

sub ShowTransactions {
	my $statement = $Session->{current}{statement};
	return if !$statement or $isNewStatement;
	print HTMLStart( 'div' . ClassAttribute('contentgroup') );
	ShowTransactionEdit();
	ShowTransactionList(FALSE);
	ShowTransactionList(TRUE);
	ResetFloat();
	print HTMLEnd('div');
}

sub ShowDetails {
	my $transaction = $Session->{current}{transaction};
	return if !$transaction or $isNewTransaction;
	my $detail = $Session->{current}{detail};
	return if !$detail;
	my $details = ShowDetailList();
	return if !$details and !$detail;
	print HTMLStart( 'div' . ClassAttribute('contentgroup') );
	ShowDetailEdit();
	print $details;
	ResetFloat();
	print HTMLEnd('div');
}

# ---------------------------------------------------------------------------------------------
sub ShowStatementList {
	my $account = $Session->{current}{account};
	return if !$account or $account eq "new";
	print HTMLStart( 'div' . ClassAttribute('content statements') );
	print HTMLStartEnd( 'div' . ClassAttribute('statementsheader'), "Statements for<br>$Accounts{$account}{accountname}" );
	print HTMLStart( 'div' . ClassAttribute('statementslist') );
	my %showStatements;
	foreach my $statement ( ( tied %Statements )->select_where("account = '$account'") ) {
		next if $statement eq $Accounts{$account}{currentstatement} or $statement eq $Accounts{$account}{recurringstatement};
		$showStatements{ $Statements{$statement}{statementdate} } = $statement;
	}
	print Indented( Select( '(current)',   'statementlistitem', 'statement', $Accounts{$account}{currentstatement} ) );
	print Indented( Select( '(recurring)', 'statementlistitem', 'statement', $Accounts{$account}{recurringstatement} ) );
	my $lastYear = '';
	foreach my $statementDate ( reverse sort { uc($a) cmp uc($b) } keys %showStatements ) {
		if ( $statementDate =~ m"^(\d\d\d\d)" ) {
			my $year = $1;
			if ( $year ne $lastYear ) { print Indented( HTMLEnclosed( 'span' . ClassAttribute('statementlistitem statementlistgroup'), "---------- " . $year . " ----------" ) ); }
			$lastYear = $year;
		}
		my $statement = $showStatements{$statementDate};
		print Indented( Select( $statementDate, 'statementlistitem', 'statement', $statement ) );
	}
	print HTMLEnd('div');
	print HTMLEnd('div');
}

sub ShowStatementEdit {
	my $statement = $Session->{current}{statement};
	return if !$statement;
	return if $isRecurring;
	my $account = $Session->{current}{account};
	foreach my $field ( keys %{ $moneyFields{statement} } ) {
		$Session->{edit}{statement}{$field} = FormatAmount( Amount( $Session->{edit}{statement}{$field} ), 1 );
	}
	$Session->{edit}{statement}{statementdate} ||= '';
	if ( ManualStatementBalance( $Session->{edit}{statement} ) ) {
		foreach my $field ( 'statementadditions1', 'statementadditions2', 'statementsubtractions1', 'statementsubtractions2' ) {
			$Session->{edit}{statement}{$field} = '';
		}
	}
	EditFormHeader( 'statement', $statement );
	print HTMLStartEnd(
		'tr',
		HTMLEnclosed('th style="border:none;"'),
		HTMLEnclosed( 'th' . ClassAttribute('statementsheader'), 'Statement' ),
		HTMLEnclosed( 'th' . ClassAttribute('statementsheader'), 'Transactions' ),
		HTMLEnclosed( 'th' . ClassAttribute('statementsheader'), 'Discrepancy' )
	);
	print HTMLStartEnd(
		'tr',
		HTMLEnclosed( 'th' . ClassAttribute('statementsheader'), 'Statement Date' ),
		HTMLEnclosed( 'td', InputField( 'statement', 'statementdate', 10, '', '', 1 ) ),
		$isCurrent ? HTMLEnclosed( 'td colspan=2 style="align=center;"', '(current statement)' ) : ''
	);
	my $accounttype = $Accounts{$account}{accounttype};
	my ( $Begin, @Rows ) = @{ $StatementTotalTypes{$accounttype} };
	my ( $field, $label ) = split m"=", $Begin;
	TableRow( $label, InputField( 'statement', $field, '', !$Session->{current}{adminmode}, '', 2 ) );
	my $tabindex = 2;

	foreach my $Row (@Rows) {
		my ( $field, $label ) = split m"=", $Row;
		print HTMLStart('tr');
		print HTMLStartEnd( "th style='text-align:right;'", $label );
		foreach my $section ( 'statement', 'transaction', 'discrepancy' ) {
			my $fld   = $section . $field;
			my $style = '';
			if ( $fld eq 'discrepancyendingbalance' ) {
				my $bal = $Session->{edit}{statement}{$fld};
				$bal =~ s",""g;
				$bal += 0;
				$style = 'background-color:plum;border-color:red;' if $bal;
			}
			my $useTabIndex = '';
			if ( $section eq 'statement' ) {
				$tabindex++;
				$useTabIndex = $tabindex;
			}
			print HTMLStartEnd( 'td', InputField( 'statement', $fld, '', ( $section ne 'statement' or ( $field eq 'endingbalance' and $Session->{edit}{statement}{statementdate} ) ), $style, $useTabIndex ) );
		}
		print HTMLEnd('tr');
	}
	my $Buttons = "";
	$Buttons .= Button( 'Save', 'editstatementbutton', 'Submit', 'editstatement', 'save' ) if $isCurrent or $Session->{current}{adminmode};
	$Buttons .= Button( 'Finalize',   'editstatementbutton', 'Submit', 'editstatement', 'finalize' )   if $isCurrent;
	$Buttons .= Button( 'Unfinalize', 'editstatementbutton', 'Submit', 'editstatement', 'unfinalize' ) if $isLatest;
	print HTMLStartEnd( 'tr', HTMLEnclosed( 'td colspan=5', $Buttons ) );
	EditFormFooter();
}

# ---------------------------------------------------------------------------------------------
sub ShowTransactionList {
	my ($showCleared) = @_;
	my $statement = $Session->{current}{statement};
	return if !$statement or $isNewStatement;
	my $StatementDate = $isCurrent ? '(current)' : $isRecurring ? '(recurring)' : $Statements{$statement}{statementdate};
	my $account       = $Session->{current}{account};
	my $isChecking    = $Accounts{$account}{accounttype} eq 'd';
	$Session->{current}{transactionsort} = 'date' if $Session->{current}{transactionsort} eq 'checknumber' and !$isChecking;
	my %trans;
	my %isFuture;
	my %isPlus;

	foreach my $transaction ( ( tied %Transactions )->select_where("statementkey = '$statement'") ) {
		my $cleared = $Transactions{$transaction}{cleared} && $Session->{current}{transactionsort} eq 'date';
		next if $showCleared && !$cleared or !$showCleared && $cleared;
		my $date = FormatDate( $Transactions{$transaction}{date} );
		my $chk  = $isChecking ? FormatCheck( $Transactions{$transaction}{checknumber} ) : '';
		my $amt  = FormatAmount( $Transactions{$transaction}{amount} );
		if ( $Transactions{$transaction}{transactiontype} =~ m"^d" ) {
			$isPlus{$transaction} = 1;
			my $sign = $isChecking ? '+' : '-';
			$amt =~ s"\.(\d\d) ".$1$sign";
		}
		my $desc = FormatDesc( $Transactions{$transaction}{description}, 20 );
		my $item = $date . $chk . $amt . $desc;
		$item = $desc . $date . $amt . $chk if $Session->{current}{transactionsort} eq 'description';
		$item = $chk . $date . $desc . $amt if $Session->{current}{transactionsort} eq 'checknumber';
		$item = $amt . $desc . $date . $chk if $Session->{current}{transactionsort} eq 'amount';
		$item .= ":$transaction";
		$trans{$item}           = $transaction;
		$isFuture{$transaction} = $Transactions{$transaction}{date} gt $Now{date};
	}
	return if !%trans;
	my $prefix = '';
	my $mass   = '';
	if ($isRecurring) {
		$prefix = 'Recurring ';
		$mass   = 'Post';
	} elsif ($isCurrent) {
		$prefix = $showCleared ? 'Cleared ' : 'Open ';
		$mass   = $showCleared ? 'Unclear'  : 'Clear';
	} else {
		$prefix = 'Cleared ';
	}
	$mass = $mass ? Button( "$mass Selected Transactions", 'transactionmassbutton' ) : '';
	print HTMLStart( 'div' . ClassAttribute('content transactions') );
	print HTMLStart("form method='post'");
	print HTMLStartEnd( 'div' . ClassAttribute('transactionsheader'), "${prefix}Transactions for<br>$Accounts{$account}{accountname}/$StatementDate", '<br>', $mass, HTMLSingle("input type=hidden name=action value=massselect") );
	print HTMLStart( 'div' . ClassAttribute('transactionslist') );
	my @trans = sort { uc($a) cmp uc($b) } keys %trans;
	@trans = reverse @trans if $Session->{current}{transactionsort} eq 'checknumber';

	foreach my $trans (@trans) {
		my $key = $trans{$trans};
		print HTMLStart( 'div' . ClassAttribute('transactionlistline') );
		if ( $isCurrent or $isRecurring ) {
			my $class = $isFuture{$key} ? 'transactionlistitemfuture' : 'transactionlistitemuncleared';
			$class = 'transactionlistitemcleared' if $Transactions{$key}{cleared};
			$class .= ' transactionlistitemplus' if $isPlus{$key};
			print Indented( Select( Display($trans), $class, 'transaction', $key ) );
			print HTMLStart( 'div' . ClassAttribute('transactionlistbuttons') );
			my $tranAction = '';
			$tranAction = 'Unclear' if $isCurrent and $Transactions{$key}{cleared};
			$tranAction = 'Clear'   if $isCurrent and !$Transactions{$key}{cleared};
			$tranAction = 'Post'    if $isRecurring;

			if ($tranAction) {
				my $tranaction = lc $tranAction;
				print Indented( HTMLSingle( "input type=checkbox name='$key.$tranaction'" . ClassAttribute('checkbox nomargin') ) );
				print Indented( Button( $tranAction, 'transactionlistbutton', 'Select', $tranaction, $key ) );
			}
			print Indented( Button( 'Delete', 'transactionlistbutton', 'Select', 'deletetransaction', $key ) );
			print HTMLEnd("div");
			ResetFloat();
		} else {
			print Select( Display($trans), 'transactionlistitemclosed', 'transaction', $key );
		}
		print HTMLEnd("div");
	}
	print HTMLEnd('div');
	print HTMLEnd('form');
	print HTMLEnd('div');
}

sub ShowTransactionEdit {
	my $transaction = $Session->{current}{transaction};
	return if !$transaction;
	my $newTransaction = $transaction eq 'new';
	foreach my $field ( keys %{ $moneyFields{transaction} } ) {
		$Session->{edit}{transaction}{$field} = Amount( $Session->{edit}{transaction}{$field} );
	}
	$Session->{edit}{transaction}{checknumber} = '' if !$Session->{edit}{transaction}{checknumber};
	my $account    = $Session->{current}{account};
	my $statement  = $Session->{current}{statement};
	my $readonly   = !$isCurrent && !$isRecurring;
	my $detailDiff = $Session->{edit}{transaction}{amount};
	$detailDiff = 0 if $detailDiff !~ m"^[0-9\.\-]+$";
	my $hasDetail = FALSE;

	if ( !$newTransaction ) {
		foreach my $detail ( ( tied %Details )->select_where("transactionkey = '$transaction'") ) {
			$detailDiff -= $Details{$detail}{amount};
			$hasDetail = TRUE;
		}
	}
	$detailDiff = 0 if $detailDiff != 0 and abs($detailDiff) < 0.005;
	$detailDiff = Amount($detailDiff) if $detailDiff;
	foreach my $field ( keys %{ $moneyFields{transaction} } ) {
		$Session->{edit}{transaction}{$field} = FormatAmount( $Session->{edit}{transaction}{$field}, 1 );
	}
	EditFormHeader( 'transaction', $transaction );
	print HTMLStartEnd( "tr", HTMLEnclosed( 'th colspan=2' . ClassAttribute('transactionsheader'), "Transaction" ) );
	my $accounttype = $Accounts{$account}{accounttype};
	my @trantypes   = sort keys %{ $AccountTypes{$accounttype}{transactiontypes} };
	ChoiceField( 'transaction', 'Transaction Type', $readonly, \@trantypes, \%TransactionTypes );
	EditField( 'transaction', 'Check Number', 5, $readonly, $isCurrent ? " last check# $Accounts{$account}{lastcheck}, use + for next" : '' );
	EditField( 'transaction', 'Date', 10, $readonly, 'enter a date, or +/- days from today' );
	EditField( 'transaction', 'Description',  50 );
	EditField( 'transaction', 'Amount',       '', $readonly, $Session->{edit}{transaction}{cleared} ? 'this transaction has cleared' : '' );
	EditField( 'transaction', 'Description2', 50 );
	EditField( 'transaction', 'Description3', 50 );
	ChoiceField( 'transaction', 'Increment', FALSE, \@repeatNames ) if $isRecurring;
	TableRow( 'Detail Difference', HTMLSingle("input type=text name=detaildiff value='$detailDiff' readonly='readonly' style='text-align:right;background-color:plum;border-color:red;' size=10") )
		if $detailDiff and $hasDetail;
	print HTMLStart('tr');
	print HTMLStart('td colspan=2');
	print Indented( Button( 'Save', 'edittransactionbutton', 'Submit', 'edittransaction', 'save' ) );

	if ( $transaction ne 'new' ) {
		if ($isCurrent) {
			if ( $Session->{edit}{transaction}{cleared} ) {
				print Indented( Button( 'Unclear', 'edittransactionbutton', 'Select', 'unclear', $transaction ) );
			} else {
				print Indented( Button( 'Clear', 'edittransactionbutton', 'Select', 'clear', $transaction ) );
			}
		}
		if ($isRecurring) {
			print Indented( Button( 'Post', 'edittransactionbutton', 'Select', 'post', $transaction ) );
		}
		if ( $isCurrent or $isRecurring ) {
			print Indented( Button( 'Delete',     'edittransactionbutton', 'Submit', 'edittransaction', 'delete' ) );
			print Indented( Button( 'New',        'edittransactionbutton', 'Select', 'transaction',     'new' ) );
			print Indented( Button( 'New Detail', 'edittransactionbutton', 'Select', 'detail',          'new' ) );
		}
	}
	print HTMLEnd('td');
	print HTMLEnd('tr');
	EditFormFooter();
}

# ---------------------------------------------------------------------------------------------
sub ShowDetailList {
	my $transaction = $Session->{current}{transaction};
	return if !$transaction or $transaction eq 'new' or !$Transactions{$transaction};
	my $haveDetail = FALSE;
	my $List       = "";
	$List .= HTMLStart( 'div' . ClassAttribute('content details') );
	$List .= HTMLStartEnd( 'div' . ClassAttribute('detailsheader'), "Transaction Details" );
	foreach my $detail ( ( tied %Details )->select_where("transactionkey = '$transaction'") ) {
		$haveDetail = TRUE;
		my $amt = FormatAmount( Amount( $Details{$detail}{amount} ), 1 );
		my $desc = $Details{$detail}{description};
		$List .= Select( $amt . ' ' . $desc, 'detaillistitem', 'detail', $detail );
	}
	$List .= HTMLEnd('div');
	return $List if $haveDetail;
}

sub ShowDetailEdit {
	my $detail = $Session->{current}{detail};
	return if !$detail;
	foreach my $field ( keys %{ $moneyFields{detail} } ) {
		$Session->{edit}{detail}{$field} = FormatAmount( Amount( $Session->{edit}{detail}{$field} ), 1 );
	}
	EditFormHeader( 'detail', $detail );
	print HTMLStartEnd( "tr", HTMLStartEnd( 'th colspan=2' . ClassAttribute('detailsheader'), "Detail" ) );
	EditField( 'detail', 'Amount' );
	EditField( 'detail', 'Description', 30 );
	print HTMLStart('tr');
	print HTMLStart('td colspan=2');
	print Indented( Button( 'Save',   'editdetailbutton', 'Submit', 'editdetail', 'save' ) );
	print Indented( Button( 'Delete', 'editdetailbutton', 'Submit', 'editdetail', 'delete' ) ) if $detail ne 'new';
	print Indented( Button( 'New',    'editdetailbutton', 'Select', 'detail',     'new' ) ) if $detail ne 'new';
	print HTMLEnd('td');
	print HTMLEnd('tr');
	EditFormFooter();
}

# ---------------------------------------------------------------------------------------------
# End
1;
